
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define ARG_NUM 7+1
#define ARG_FIRST 1

void add_mass( int id, float mass, float x, float y, float z );
void add_spring( int id1, int id2, float kp, float kd, float len );




main( int argc, char* argv[] ) {

	if( argc != ARG_NUM ) {
		cerr << "Syntax: ball_maker <arcs> <slices> <radius> <mass>" 
			" <init_height> <kp> <kd>" << endl;
		cerr << argc << endl << argv[0] << endl << argv[1] << endl;
		exit( -1 );
	}

	int arcs = atoi(argv[ARG_FIRST+0]);
	int slices = atoi(argv[ARG_FIRST+1]);
	float radius = atof(argv[ARG_FIRST+2]);
	float mass = atof(argv[ARG_FIRST+3]);
	float init_height = atof(argv[ARG_FIRST+4]);
	float kp = atof(argv[ARG_FIRST+5]);
	float kd = atof(argv[ARG_FIRST+6]);

	int id=1;
	add_mass( id++, mass, 0, 0, init_height );
	add_mass( id++, mass, 0, 0, radius + init_height );
	add_mass( id++, mass, 0, 0, -radius + init_height );
	add_spring( 1, 2, kp, kd, radius );
	add_spring( 1, 3, kp, kd, radius );

	for( int slice=0; slice<slices; slice++ ) {
		for( int arc=0; arc<arcs-1; arc++ ) {
			if( slice != slices ) {
				float x, y, z;
				x = radius*sin( PI*(arc+1)/arcs )*cos( 2*PI * (slice+1)/slices);
				y = radius*sin( PI*(arc+1)/arcs )*sin( 2*PI * (slice+1)/slices);
				z = radius*cos( PI*(arc+1)/arcs );
				add_mass( id++, mass, x, y, z + init_height );

				add_spring( id-1, 1, kp, kd, radius );

				if( arc==0 )
					add_spring( 2, id-1, kp, kd, 2*radius*sin(PI/arcs/2) );
				else
					add_spring( id-1, id-2, kp, kd, 2*radius*sin(PI/arcs/2) );

				if( arc==arcs-2 )
					add_spring( 3, id-1, kp, kd, 2*radius*sin(PI/arcs/2) );
			}

			if( slice != 0 ) {
				// do between slice springs
				// structural
				float frad = radius * sin( PI/arcs*(arc+1) );
				float len = 2*frad*sin( PI/slices );
				add_spring( id-1, id-1-(arcs-1), kp, kd, len );

				// shear springs
				if( arc!=0 ) {
					float fprevrad = radius * sin( PI/arcs*(arc) );
					float prevlen = 2*fprevrad*sin(PI/slices);
					float lmean = (prevlen + len)/2;
					float l = 2*radius*sin(PI/arcs/2);
					float xdist = sqrt((lmean*lmean) + (l*l));
					add_spring( id-1, id-1-(arcs-1)-1, kp, kd, xdist );
					add_spring( id-1-1, id-1-(arcs-1), kp, kd, xdist );
				}
			}
		}
	}

	// do the final slice

	for( int arc=0; arc<arcs-1; arc++ ) {
		// do between slice springs
		// structural
		int idMax = id-1;
		float frad = radius * sin( PI/arcs*(arc+1) );
		float len = 2*frad*sin( PI/slices );
		add_spring( arc+4, idMax-(arcs-2)+arc, kp, kd, len );

		// shear springs
		if( arc!=0 ) {
			float fprevrad = radius * sin( PI/arcs*(arc) );
			float prevlen = 2*fprevrad*sin(PI/slices);
			float lmean = (prevlen + len)/2;
			float l = 2*radius*sin(PI/arcs/2);
			float xdist = sqrt((lmean*lmean) + (l*l));
				add_spring( arc+4, idMax-(arcs-1)+arc, kp,kd, xdist );
				add_spring( arc+4-1, idMax-(arcs-1)+arc+1,kp,kd,xdist);
		}
	}

	cout << "ground 0 0 1 0" << endl;
	cout << endl << "net" << endl << "redisplay" << endl;
}

void add_mass( int id, float mass, float x, float y, float z ) {

	cout << "masspt " << id << " " <<  mass << " " << x << "," << y << "," << z
		 << endl;
}


void add_spring( int id1, int id2, float kp, float kd, float len ) {

	cout << "spring " << id1 << " " << id2 << " " << kp << " " << kd
		<< " " << len << endl;
}



