#include <iostream.h>
#include <math.h>
#include <stdlib.h>

#define ARG_NUM 8+1
#define ARG_FIRST 1

main( int argc, char* argv[] ) {

	if( argc != ARG_NUM ) {
		cerr << "Syntax: flag_maker <cols> <rows> <dcol> <drow> <mass> <kp> <kd> <init_height>" << endl;
		cerr << argc << endl << argv[0] << endl << argv[1] << endl;
		exit( -1 );
	}

	int cols = atoi(argv[ARG_FIRST+0]);
	int rows = atoi(argv[ARG_FIRST+1]);
	float dcol = atof(argv[ARG_FIRST+2]);
	float drow = atof(argv[ARG_FIRST+3]);
	float mass = atof(argv[ARG_FIRST+4]);
	float kp = atof(argv[ARG_FIRST+5]);
	float kd = atof(argv[ARG_FIRST+6]);
	float init_h = atof(argv[ARG_FIRST+7]);

	int id=1;
	for( int y=0; y<rows; y++ ) {
		for( int x=0; x<cols; x++ ) {
			cout << "masspt " << id << " " << mass << " " << x*dcol << ",0," 
				 << init_h - y*drow << endl;
			id++;
		}
	}

	cout << endl;

	// first set of springs: structural verticals
	for( int i=1; i<=cols*(rows-1); i++ )
		cout << "spring " << i << " " << i+cols << " " << kp << " " << kd << " "
			 << drow << endl;

	cout << endl;

	// now the structural springs for each row
	for( int row=0; row<rows; row++ ) {
		for( int col=1; col<cols; col++ ) {
			cout << "spring " << (row*rows)+col << " " << (row*rows)+col+1 << " " 
				<< kp << " " << kd << " " << dcol << endl;
		}
	}

	cout << endl;

	// now the shear springs
	for( int row=2; row<=rows; row++ ) {
		for( int col=2; col<=cols; col++ ) {
			cout << "spring " << ((row-1)*rows)+col << " " 
				<< ((row-1-1)*rows)+col-1 << " " 
				<< kp << " " << kd << " " 
				<< sqrt(dcol*dcol+drow*drow) << endl;
			cout << "spring " << ((row-1)*rows)+col-1 << " " 
				<< ((row-1-1)*rows)+col << " " 
				<< kp << " " << kd << " " 
				<< sqrt(dcol*dcol+drow*drow) << endl;
		}
	}

	for( int i=1; i<=cols; i++ )
		cout << "fix " << i << endl;

    cout << "ground 0 0 1 0" << endl << "cloth_model" << endl << endl;

	cout << endl << "net" << endl << "redisplay" << endl;
}

