#include <iostream.h>
#include <math.h>
#include <stdlib.h>

#define ARG_NUM 7+1
#define ARG_FIRST 1

int id=1;

void do_blade( float x, float y, float mass, float kp, float kd);

main( int argc, char* argv[] ) {

	if( argc != ARG_NUM ) {
		cerr << "Syntax: grass_maker <cols> <rows> <dcol> <drow> <mass> <kp> <kd>" << endl;
		cerr << argc << endl << argv[0] << endl << argv[1] << endl;
		exit( -1 );
	}

	int cols = atoi(argv[ARG_FIRST+0]);
	int rows = atoi(argv[ARG_FIRST+1]);
	float dcol = atof(argv[ARG_FIRST+2]);
	float drow = atof(argv[ARG_FIRST+3]);
	float mass = atof(argv[ARG_FIRST+4]);
	float kp = atof(argv[ARG_FIRST+5]);
	float kd = atof(argv[ARG_FIRST+6]);

	for( int y=0; y<rows; y++ ) {
		for( int x=0; x<cols; x++ ) {
			do_blade( x*dcol, y*drow, mass, kp, kd );
		}
	}

	cout << endl;

    cout << "ground 0 0 1 0" << endl << endl;

	cout << endl << "net" << endl << "redisplay" << endl;
}


void do_blade( float x, float y, float mass, float kp, float kd ) {

	for( int i=0; i<=3; i++ ) {
		cout << "masspt " << id << " " << mass << " " << x << "," << y
			<<"," << i*0.5 << endl;
		if( i==0 || i==1 )
			cout << "fix " << id << endl;
		else		// flexion spring
			cout << "spring " << id << " " << id-2 << " " << kp << " " << kd
				 << " 1 n" << endl;

		if( i )		// structural spring
			cout << "spring " << id << " " << id-1 << " " << kp << " " << kd
				 << " 0.5" << endl;
		id++;
	}
}
