#include <iostream.h>
#include <math.h>
#include <stdlib.h>

#define ARG_NUM 9+1
#define ARG_FIRST 1

int id=1;

void do_hair( float x, float z, float mass, float kp, float kd, int links );

main( int argc, char* argv[] ) {

	if( argc != ARG_NUM ) {
		cerr << "Syntax: hair_maker <cols> <rows> <dcol> <drow> <mass> <kp> <kd> <init_height> <links>" << endl;
		cerr << argc << endl << argv[0] << endl << argv[1] << endl;
		exit( -1 );
	}

	int cols = atoi(argv[ARG_FIRST+0]);
	int rows = atoi(argv[ARG_FIRST+1]);
	float dcol = atof(argv[ARG_FIRST+2]);
	float drow = atof(argv[ARG_FIRST+3]);
	float mass = atof(argv[ARG_FIRST+4]);
	float kp = atof(argv[ARG_FIRST+5]);
	float kd = atof(argv[ARG_FIRST+6]);
	float init_h = atof(argv[ARG_FIRST+7]);
	int links = atof(argv[ARG_FIRST+8]);

	for( int y=0; y<rows; y++ ) {
		for( int x=0; x<cols; x++ ) {
			do_hair( x*dcol, init_h - y*drow, mass, kp, kd, links );
		}
	}

	cout << endl;

    cout << "ground 0 0 1 0" << endl << "drag_coeffs 0.1 1.0" << endl << endl;

	cout << endl << "net" << endl << "redisplay" << endl;
}


void do_hair( float x, float z, float mass, float kp, float kd, int links ) {

	for( int i=0; i<=links; i++ ) {
		cout << "masspt " << id << " " << mass << " " << x << "," << i*0.5
			+ ((i>1)?(random() % 10)/10.0:0)
			<<"," << z+i*0.5 + ((i>1)?((random() % 10)/10.0):0) << endl;
		if( i==0 || i==1 )
			cout << "fix " << id << endl;
		else		// flexion spring
			cout << "spring " << id << " " << id-2 << " " << kp << " " << kd
				 << " 1.414 n" << endl;

		if( i )		// structural spring
			cout << "spring " << id << " " << id-1 << " " << kp << " " << kd
				 << " 0.7071" << endl;
		id++;
	}
}
