/************************************************************
	FILE: lib_image.h
          prototypes for lib_image.C
************************************************************/

typedef struct sgiheader
{
  short magic;
  char  storage;
  char  bpc;
  unsigned short dim;
  unsigned short xsize;
  unsigned short ysize;
  unsigned short zsize;
  long pixmin;
  long pixmax;
  char iname[80];
  long cmap;
} SGIHEADER;

typedef struct image {
  SGIHEADER h;
  char *data;
  char *data2;
  char name[80];
  struct image *next;
} IMAGE;

extern IMAGE *Image;
extern IMAGE *find_image();

char *mymalloc(int size);
prheader(SGIHEADER h);
unsigned char getbyte(FILE *inf);
unsigned short getshort(FILE *inf);
long getlong(FILE *inf);
putbyte(FILE *outf, unsigned char val);
putshort(FILE *outf, unsigned short val);
static int putlong(FILE *outf, unsigned long val);
IMAGE *find_image(char *name);
IMAGE *newimage(char *name);
int texload(ClientData clientData,
		   Tcl_Interp *interp,
		   int argc, char **argv);
image_convert(IMAGE *i);
void print(int nargs, STR args[]);
void save(int nargs, STR args[]);
put_image_verbatim(char *image, SGIHEADER *h, char *name);
pr_image(char *image, SGIHEADER *h);
prscanline(int y, char *image, SGIHEADER *h);
read_verbatim(FILE *inf, char *image, SGIHEADER *h);
read_rle(FILE *inf, char *image, SGIHEADER *h);
read_header(SGIHEADER *h, FILE *inf);
getiline(FILE *inf, char *image,
		 int rleoffset, int rlelength, int zsize);
void expandrow(unsigned char *optr,
		  unsigned char *iptr, int z);
readlongtab(FILE *inf, long *table, int size);
int texhead(ClientData clientData,
		   Tcl_Interp *interp,
		   int argc, char **argv);










